<id>
Improved Email Check on Registration for YaBB 2.5/2.5.2
</id>

<version>
1.1
</version>

<mod info>
This mod needs Net::DNS to be installed on your server.
 
What does it do? 
 
- it checks valid syntax on given email address.
- it checks if the domain exists given in the address.
- it checks if the user is known on the given SMTP server. 
- it checks if the smtp server(s) are online and valid.
- it checks if the users mailbox is full.
 
Also it adds a second email field on registration for verification of typing errors. 
 
Known restrictions: 
- Not all mailservers reply the same if a user does not exist and you may be amazed how many stupid domains exists, like hotlmail.com and such, so not every typo will be caught on domain check. 

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload the 'Mail' folder to the 'yabb2/Modules/' directory in ASCII mode.
4) Go to Admin Center - Forum Settings - Members - Registration to enable the feature.

Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/Register.lng
Sources/Register.pl

Version History
---------------
V1.0 First release by Spikecity for YaBB 2.1 - 11th February 2007
V1.1 - Updated for YaBB 2.5/2.5.2 by Derek Barnstorm - 10th December 2012
</mod info>

<author>
Spikecity
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$impemailcheck_mod = "Improved Email Check on Registration|Spikecity|Extensive email check during registration.|1.1|10th December 2012";
	push (@installed_mods, "$impemailcheck_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$RegAgree = $RegAgree;					# Set to 1 to display the registration agreement when registering
</search for>

<add after>
\$imp_email_check = $imp_email_check;    # Set to 1 to enable improved e-mail check
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			validate => 'boolean',
			depends_on => ['regtype!=0'],
		},
</search for>

<add after>
		{
			description => qq~<label for="imp_email_check">$admin_txt{'imp_email_check'}</label>~,
			input_html => qq~<input type="checkbox" name="imp_email_check" id="imp_email_check" value="1"${ischecked($imp_email_check)} />~,
			name => 'imp_email_check',
			validate => 'boolean',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'imp_email_check' => 'Enable improved e-mail checking?<br /><span class="small">Checks if the e-mail domain exists, if the user is known on the given SMTP server, if the smtp server(s) are online and valid, and if the users mailbox is full. Also adds a second e-mail field to the registration page for verification.<br />Note that this setting requires Net::DNS to be installed on your server.</span>',
</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
## Register ##
</search for>

<add after>
'email_mismatch'       => "The e-mail addresses do not match.",
</add after>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
'81' => 'Choose password',
</search for>

<add before>
'70' => 'Verify e-mail',
</add before>

<search for>
);

%pwstrengthmeter_txt = (
</search for>

<add before>
'error_email2' => 'You must verify your e-mail.',
'error_email3' => 'Your e-mail is not equal the confirmation e-mail.',
</add before>

<search for>
1;
</search for>

<add before>

%mail_check = (
'address' => 'The entered e-mail address:',
'invalid' => 'is invalid.',
'reason' => 'The error is:',
'0' => 'Check is successful.',
'1' => 'Bad syntax of e-mail address.',
'2' => 'Mail domain mentioned in the e-mail address is unknown.',
'3' => 'Timeout has happened during DNS checks.',
'4' => 'User is unknown on SMTP server.',
'5' => 'Timeout has happened during SMTP checks.',
'6' => 'All SMTP servers for the e-mail domain were found unreachable during SMTP checks.',
'7' => 'Mailbox is temporarily full but probably a valid username.', 
);

</add before>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	if ($birthday_on_reg) {
		&timetostring($date);
</search for>

<add before>
	if ($imp_email_check) {
	    $yymain .= qq~
	<tr>
		<td class="windowbg" align="right" valign="top"><label for="email2"><b>$register_txt{'70'}:</b></td>
		<td class="windowbg2"><input type="text" maxlength="100" name="email2" id="email2" size="45" /> *</td>
	</tr~;
	}
	
</add before>

<search for>
			document.creator.email.focus();
			return false;
		}~ .
</search for>

<add after>

		($imp_email_check ? qq~
		if (document.creator.email2.value == '') {
			alert("$register_txt{'error_email2'}");
			document.creator.email2.focus();
			return false;
		}
		if (document.creator.email.value != document.creator.email2.value) {
			alert("$register_txt{'error_email3'}");
			document.creator.email.focus();
			return false;
		}~ : '') .
</add after>

<search for>
	# Make sure users can't register with banned details
</search for>

<add before>
    # If enabled check if user has a valid e-mail address (needs Net::DNS to be installed)
    if ($imp_email_check) {
	    my $helo;
	    use Mail::CheckUser (qw(check_email last_check));
	    $Mail::CheckUser::Sender_Addr = $webmaster_email;
	    if ($boardurl =~ /http\:\/\/(.*?)\//){ $Mail::CheckUser::Helo_Domain = $1; }
	    if (check_email($member{'email'})) {
		    my $email_ok = 1;
	    } else {
		    my $failure = last_check()->{code};
		    &fatal_error("", "$mail_check{'address'} $member{'email'} $mail_check{'invalid'} $mail_check{'reason'} $mail_check{$failure}");
	    }
	}
	
</add before>

<search for>
	&fatal_error("id_to_long","($member{'regusername'})") if length($member{'regusername'}) > 25;
</search for>

<add after>
	&fatal_error("email_mismatch") if ($member{'email'} ne $member{'email2'} && $imp_email_check);
</add after>



